precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform int alignType;
uniform vec2 inputSize;
uniform vec2 screenSize;
uniform int mode;//0 repeat, 1 mirrored repeat,2 clamp to edge, 3 clamp to border(black)

vec4 getOutColor(vec2 uv, int mode) {
    vec4 color = vec4(0.0);
    if(mode == 0) {
        uv = fract(uv);
        color = texture2D(inputImageTexture, uv);
    } else if(mode == 1) {
        uv += 1.0;
        uv *= 0.5;
        uv = fract(uv);
        uv = abs((uv-0.5) * 2.0);
        color = texture2D(inputImageTexture, uv);
    } else if(mode == 2){
        color = texture2D(inputImageTexture, uv);
    } else {
        if(uv.x < 0.0 || uv.x > 1.0 || uv.y < 0.0 || uv.y > 1.0) {
            color = vec4(vec3(0.0), 0.0);
        } else {
            color = texture2D(inputImageTexture, uv);
        }
    }
    return color;
}

void main()
{
    vec2 uv = textureCoordinate;

    float scale = inputSize.y / inputSize.x;
    float y = (screenSize.x * scale)/screenSize.y;
    //竖屏
    if(screenSize.x < screenSize.y){
        uv.y /= y;
        if(alignType == 1){
            uv.y -= 1.0/y - 1.0;
        }else if(alignType == 2){
            uv.y -= (1.0/y - 1.0) * 0.5;
        }
    }else{
        uv.y /= y;
        if(alignType == 1){
            uv.y += (screenSize.x * scale - screenSize.y)/(screenSize.x * scale);
        }else if(alignType == 2){
            uv.y += (screenSize.x * scale - screenSize.y)/(screenSize.x * scale) * 0.5;
        }
    }
    gl_FragColor = getOutColor(uv, mode);
}