precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 screenSize;
uniform vec2 inputSize;
uniform int alignType;

void main()
{
    vec2 uv = textureCoordinate;

    float scale = inputSize.y / inputSize.x;
    float y = (screenSize.x * scale)/screenSize.y;
    //竖屏
    if(screenSize.x < screenSize.y){
        uv.x *= y;
        if(alignType == 1){
            uv.x +=  0.5 - y*0.5;
        }else if(alignType == 2){
            uv.x +=  (0.5 - y*0.5);
        }
    }else{
        uv.y /= y;
        if(alignType == 1){
            uv.y += (screenSize.x * scale - screenSize.y)/(screenSize.x * scale);
        }else if(alignType == 2){
            uv.y += (screenSize.x * scale - screenSize.y)/(screenSize.x * scale) * 0.5;
        }
    }

    gl_FragColor = texture2D(inputImageTexture, uv);
}