precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 imageSize;
uniform vec2 frameSize;
uniform vec4 rect;//{l,t,r,b}
void main()
{
    vec2 uv = textureCoordinate * imageSize;
    float dx = imageSize.x - frameSize.x;
    float l = rect.x, t = rect.y, r = rect.z, b = rect.w;
    float w = r - l;
    float h = b - t;
    if(uv.x < l * frameSize.x) {
        uv.x /= frameSize.x;
    } else if(uv.x < r * frameSize.x + dx) {
        uv.x /= frameSize.x;
        uv.x -= l;
        while(uv.x > w) uv.x -= w;
        uv.x += l;
    } else {
        uv.x -= dx;
        uv.x /= frameSize.x;
    }

    float dy = imageSize.y - frameSize.y;
    if(uv.y < t * frameSize.y) {
        uv.y /= frameSize.y;
    } else if(uv.y < b * frameSize.y + dy) {
        uv.y /= frameSize.y;
        uv.y -= t;
        while(uv.y > h) uv.y -= h;
        uv.y += t;
    } else {
        uv.y -= dy;
        uv.y /= frameSize.y;
    }
    gl_FragColor = texture2D(inputImageTexture, uv);
}