precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float iTime;

vec3 rgb2hsv(vec3 c,float time) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));
    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    vec3 hsvColor = vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
    hsvColor.z = 3.14159*2.0* fract(time*0.05)-hsvColor.z;;
    return hsvColor;
}

vec3 hsv2rgb(vec3 c,float time)
{
    vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
    vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
    vec3 resultColor = c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
    return resultColor;
}

void main()
{
    vec2 uv = textureCoordinate;
    vec4 resultColor =  texture2D(inputImageTexture, uv);
    vec4 RGBColor = resultColor;
    vec3 color = RGBColor.xyz;
    vec3 hsv = rgb2hsv(color.xyz,iTime);
    hsv.x = hsv.z;
    hsv.y = 1.0;
    hsv.z = 1.0;
    color = hsv2rgb(hsv,iTime);
    RGBColor.rgb = color;
    RGBColor.rgb *= resultColor.a;
    gl_FragColor = RGBColor;
}